# nos 🔥: Nitrous Oxide System (NOS) for Computer Vision

<p align="center">
    <a href="https://pypi.org/project/autonomi-nos/">
        <img alt="PyPi Version" src="https://badge.fury.io/py/autonomi-nos.svg">
    </a>
    <a href="https://pypi.org/project/autonomi-nos/">
        <img alt="PyPi Version" src="https://img.shields.io/pypi/pyversions/autonomi-nos">
    </a>
    <a href="https://pypi.org/project/autonomi-nos/">
        <img alt="PyPi Downloads" src="https://img.shields.io/pypi/dm/autonomi-nos">
    </a>
    <a href="https://discord.gg/QAGgvTuvgg">
        <img alt="Discord" src="https://img.shields.io/badge/discord-chat-purple?color=%235765F2&label=discord&logo=discord">
    </a>
</p>

**NOS** is a PyTorch library for optimizing and running lightning-fast inference of popular computer vision models. NOS inherits its name from "Nitrous Oxide System", the performance-enhancing system typically used in racing cars. NOS is designed to be modular and easy to extend.

## Why NOS?
- ⚡️ **Fast**: Built for PyTorch and designed to optimize/run models faster
- 🔥 **Performant**: Run models such as SDv2 or object detection 2-3x faster out-of-the-box
- 👩‍💻 **No PhD required**: Optimize models for maximum HW performance without a PhD in ML
- 📦 **Extensible**: Easily add optimization and HW-support for custom models
- ⚙️ **HW-accelerated:** Take full advantage of your HW (GPUs, ASICs) without compromise
- ☁️ **Cloud-agnostic:** Run on any cloud HW (AWS, GCP, Azure, Lambda Labs, On-Prem)

## Batteries Included
 - 💪 **SOTA Model Support:** NOS provides out-of-the-box support for popular CV models such as [Stable Diffusion](stabilityai/stable-diffusion-2), [OpenAI CLIP](openai/clip-vit-base-patch32), [OpenMMLab](https://github.com/open-mmlab/) object detection, tracking and more
 - 🔌 **APIs:** NOS provides out-of-the-box APIs and avoids all the ML model deployment hassles
 - 🐳 **Docker:** NOS ships with docker images to run accelerated and scalable CV workloads
 - 📈 **Multi-Platform**: NOS allows you to run models on different HW (NVIDIA, custom ASICs) without any model compilation or runtime management.


## Contribute
We welcome contributions! Please see our [contributing guide](docs/CONTRIBUTING.md) for more information.
